"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var Button = require("@uidu/button"), Button__default = _interopDefault(Button), Modal = _interopDefault(require("@uidu/modal-dialog")), React = require("react"), React__default = _interopDefault(React), constants = require("@uidu/theme/constants"), math = require("@uidu/theme/math"), styled = require("styled-components"), styled__default = _interopDefault(styled), theme = require("@uidu/theme"), Portal = _interopDefault(require("@uidu/portal")), exenv = require("exenv"), NodeResovler = _interopDefault(require("react-node-resolver")), ScrollLock = _interopDefault(require("react-scrolllock")), scrollIntoView = _interopDefault(require("scroll-into-view-if-needed")), reactTransitionGroup = require("react-transition-group"), analytics = require("@uidu/analytics"), popper = require("@uidu/popper"), FocusLock = _interopDefault(require("react-focus-lock")), memoizeOne = _interopDefault(require("memoize-one")), Body = styled__default.div.withConfig({
  displayName: "Modal__Body",
  componentId: "sc-164q298-0"
})([ "padding:40px 20px;text-align:center;" ]), Heading = styled__default.h4.withConfig({
  displayName: "Modal__Heading",
  componentId: "sc-164q298-1"
})([ "color:inherit;font-size:20px;font-style:inherit;font-weight:500;letter-spacing:-0.008em;line-height:1.2;margin-bottom:", "px;" ], constants.gridSize), Image = styled__default.img.withConfig({
  displayName: "Modal__Image",
  componentId: "sc-164q298-2"
})([ "border-top-left-radius:", "px;border-top-right-radius:", "px;height:auto;width:100%;@media (min-width:320px) and (max-width:480px){border-radius:0;}" ], constants.borderRadius, constants.borderRadius), actionItemBottomMargin = constants.gridSize() / 2, Actions = styled__default.div.withConfig({
  displayName: "Modal__Actions",
  componentId: "sc-164q298-3"
})([ "display:flex;justify-content:center;padding:0 40px ", "px;flex-flow:wrap;flex-direction:", ";" ], 40 - actionItemBottomMargin, (function(_ref) {
  return _ref.shouldReverseButtonOrder ? "row-reverse" : "normal";
})), ActionItem = styled__default.div.withConfig({
  displayName: "Modal__ActionItem",
  componentId: "sc-164q298-4"
})([ "margin:0 ", "px ", "px;" ], math.divide(constants.gridSize, 2), actionItemBottomMargin);

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

function _defineProperty(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

function _objectWithoutProperties(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

function _typeof(obj) {
  return (_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

var spotlightTheme = {
  default: {
    background: {
      default: {
        light: theme.colors.P400,
        dark: theme.colors.P400
      },
      hover: {
        light: theme.colors.P200,
        dark: theme.colors.P200
      },
      active: {
        light: theme.colors.P500,
        dark: theme.colors.P500
      },
      disabled: {
        light: theme.colors.N30,
        dark: theme.colors.DN70
      },
      selected: {
        light: theme.colors.R500,
        dark: theme.colors.R500
      },
      focus: {
        light: theme.colors.P400,
        dark: theme.colors.P400
      }
    },
    boxShadow: {
      focus: {
        light: "".concat(theme.colors.P100, " 0 0 0 2px"),
        dark: "".concat(theme.colors.P100, " 0 0 0 2px")
      }
    },
    color: {
      default: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      },
      hover: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      },
      active: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      },
      disabled: {
        light: theme.colors.N0,
        dark: theme.colors.DN30
      },
      selected: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      },
      focus: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      }
    },
    outline: {
      focus: {
        light: "none",
        dark: "none"
      }
    }
  },
  "subtle-link": {
    textDecoration: {
      hover: {
        light: "underline ".concat(theme.colors.P75),
        dark: "underline ".concat(theme.colors.P75)
      }
    },
    textDecorationLine: {
      active: {
        light: "none",
        dark: "none"
      }
    },
    boxShadow: {
      focus: {
        light: "".concat(theme.colors.P100, " 0 0 0 2px"),
        dark: "".concat(theme.colors.P100, " 0 0 0 2px")
      }
    },
    color: {
      default: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      },
      hover: {
        light: theme.colors.P75,
        dark: theme.colors.P75
      },
      active: {
        light: theme.colors.P100,
        dark: theme.colors.P100
      },
      disabled: {
        light: theme.colors.P500,
        dark: theme.colors.P500
      },
      selected: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      }
    }
  }
}, modalTheme = {
  primary: {
    background: {
      default: {
        light: theme.colors.P400,
        dark: theme.colors.P400
      },
      hover: {
        light: theme.colors.P200,
        dark: theme.colors.P200
      },
      active: {
        light: theme.colors.P500,
        dark: theme.colors.P500
      },
      disabled: {
        light: theme.colors.N30,
        dark: theme.colors.DN70
      },
      selected: {
        light: theme.colors.R500,
        dark: theme.colors.R500
      },
      focus: {
        light: theme.colors.P400,
        dark: theme.colors.P400
      }
    },
    boxShadow: {
      focus: {
        light: "".concat(theme.colors.P100, " 0 0 0 2px"),
        dark: "".concat(theme.colors.P100, " 0 0 0 2px")
      }
    },
    color: {
      default: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      },
      disabled: {
        light: theme.colors.N0,
        dark: theme.colors.DN30
      },
      selected: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      },
      focus: {
        light: theme.colors.N0,
        dark: theme.colors.N0
      }
    }
  }
};

function extract(newTheme, _ref) {
  var mode = _ref.mode, appearance = _ref.appearance, state = _ref.state;
  if (newTheme[appearance]) {
    var root = newTheme[appearance];
    return Object.keys(root).reduce((function(acc, val) {
      var node = root;
      return [ val, state, mode ].forEach((function(item) {
        node[item] && ("object" === _typeof(node[item]) ? node = node[item] : acc[val] = node[item]);
      })), acc;
    }), {});
  }
}

var spotlightButtonTheme = function(current, themeProps) {
  var _current = current(themeProps), buttonStyles = _current.buttonStyles, rest = _objectWithoutProperties(_current, [ "buttonStyles" ]);
  return _objectSpread({
    buttonStyles: _objectSpread(_objectSpread({}, buttonStyles), extract(spotlightTheme, themeProps))
  }, rest);
}, modalButtonTheme = function(current, themeProps) {
  var _current2 = current(themeProps), buttonStyles = _current2.buttonStyles, rest = _objectWithoutProperties(_current2, [ "buttonStyles" ]);
  return _objectSpread({
    buttonStyles: _objectSpread(_objectSpread({}, buttonStyles), extract(modalTheme, themeProps))
  }, rest);
};

function _typeof$1(obj) {
  return (_typeof$1 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function _extends() {
  return (_extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
    }
    return target;
  }).apply(this, arguments);
}

function _objectWithoutProperties$1(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose$1(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

function _objectWithoutPropertiesLoose$1(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties(Constructor.prototype, protoProps), staticProps && _defineProperties(Constructor, staticProps), 
  Constructor;
}

function _inherits(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  return (_setPrototypeOf = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function() {
    var result, Super = _getPrototypeOf(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) {
  return !call || "object" !== _typeof$1(call) && "function" != typeof call ? _assertThisInitialized(self) : call;
}

function _assertThisInitialized(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf(o) {
  return (_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

function _defineProperty$1(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

function noop() {}

var OnboardingModal = function(_Component) {
  _inherits(OnboardingModal, React.Component);
  var _super = _createSuper(OnboardingModal);
  function OnboardingModal() {
    var _this;
    _classCallCheck(this, OnboardingModal);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
    return _defineProperty$1(_assertThisInitialized(_this = _super.call.apply(_super, [ this ].concat(args))), "headerComponent", (function(props) {
      var HeaderElement = props.header, src = props.image;
      return HeaderElement || function() {
        return React__default.createElement(Image, {
          alt: "",
          src: src
        });
      };
    })), _defineProperty$1(_assertThisInitialized(_this), "footerComponent", (function(props) {
      var FooterElement = props.footer, actionList = props.actions, _props$experimental_s = props.experimental_shouldShowPrimaryButtonOnRight, experimental_shouldShowPrimaryButtonOnRight = void 0 !== _props$experimental_s && _props$experimental_s;
      return FooterElement || function() {
        return actionList ? React__default.createElement(Button.Theme.Provider, {
          value: modalButtonTheme
        }, React__default.createElement(Actions, {
          shouldReverseButtonOrder: experimental_shouldShowPrimaryButtonOnRight
        }, actionList.map((function(_ref, idx) {
          var text = _ref.text, key = _ref.key, rest = _objectWithoutProperties$1(_ref, [ "text", "key" ]), variant = idx ? "subtle-link" : "primary";
          return React__default.createElement(ActionItem, {
            key: key || ("string" == typeof text ? text : "".concat(idx))
          }, React__default.createElement(Button__default, _extends({
            appearance: variant,
            autoFocus: !idx
          }, rest), text));
        })))) : null;
      };
    })), _this;
  }
  return _createClass(OnboardingModal, [ {
    key: "render",
    value: function() {
      var _this$props = this.props, children = (_this$props.actions, _this$props.children), heading = _this$props.heading, props = _objectWithoutProperties$1(_this$props, [ "actions", "children", "heading" ]);
      return React__default.createElement(Modal, _extends({
        autoFocus: !0,
        components: {
          Header: this.headerComponent(this.props),
          Footer: this.footerComponent(this.props)
        },
        onClose: noop,
        scrollBehavior: "outside",
        shouldCloseOnOverlayClick: !1,
        shouldCloseOnEscapePress: !1
      }, props), React__default.createElement(Body, null, heading && React__default.createElement(Heading, null, heading), children));
    }
  } ]), OnboardingModal;
}();

function ownKeys$1(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$1(Object(source), !0).forEach((function(key) {
      _defineProperty$2(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$1(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

function _defineProperty$2(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

var duration = 100, Fade = function(_ref) {
  var hasEntered = _ref.in, children = _ref.children, onExited = _ref.onExited;
  return React__default.createElement(reactTransitionGroup.Transition, {
    in: hasEntered,
    timeout: duration,
    onExited: onExited,
    unmountOnExit: !0,
    appear: !0
  }, (function(status) {
    var style = _objectSpread$1(_objectSpread$1({}, {
      transition: "opacity ".concat(duration, "ms"),
      opacity: 0
    }), {
      entered: {
        opacity: 1
      },
      exiting: {
        opacity: 0
      }
    }[status]);
    return children(style);
  }));
}, baseShadow = "0 0 0 2px ".concat(theme.colors.P300), easing = "cubic-bezier(0.55, 0.055, 0.675, 0.19)", pulseKeframes = styled.keyframes([ "0%,33%{box-shadow:", ",0 0 0 rgba(101,84,192,1)}66%,100%{box-shadow:", ",0 0 0 10px rgba(101,84,192,0.01)}" ], baseShadow, baseShadow), animation = styled.css([ "animation:", " 3000ms ", " infinite;" ], pulseKeframes, easing), Div = styled__default.div.withConfig({
  displayName: "Target__Div",
  componentId: "sc-69iyv5-0"
})([ "z-index:", ";", " ", "" ], theme.layers.spotlight() + 1, (function(p) {
  return p.bgColor ? "background-color: ".concat(p.bgColor, ";") : null;
}), (function(p) {
  return p.radius ? "border-radius: ".concat(p.radius, "px;") : null;
})), TargetInner = styled__default(Div).withConfig({
  displayName: "Target__TargetInner",
  componentId: "sc-69iyv5-1"
})([ "", ";" ], (function(_ref) {
  return _ref.pulse ? animation : null;
})), TargetOverlay = styled__default.div.withConfig({
  displayName: "Target__TargetOverlay",
  componentId: "sc-69iyv5-2"
})([ "cursor:", ";height:100%;left:0;position:absolute;top:0;width:100%;" ], (function(p) {
  return p.onClick ? "pointer" : "auto";
})), Pulse = styled__default(Div).withConfig({
  displayName: "Target__Pulse",
  componentId: "sc-69iyv5-3"
})([ "position:absolute;", ";" ], animation);

function cloneAndOverrideStyles(node) {
  var clonedNode = node.cloneNode(!0);
  return clonedNode.style.margin = "0", clonedNode.style.position = "static", clonedNode.style.transform = "translate(0, 0) translate3d(0, 0, 0)", 
  clonedNode;
}

var Clone = function(props) {
  var pulse = props.pulse, style = props.style, target = props.target, targetBgColor = props.targetBgColor, targetOnClick = props.targetOnClick, targetNode = props.targetNode, targetRadius = props.targetRadius;
  return React__default.createElement(TargetInner, {
    pulse: pulse,
    bgColor: targetBgColor,
    radius: targetRadius,
    style: style
  }, React__default.createElement("div", {
    dangerouslySetInnerHTML: {
      __html: cloneAndOverrideStyles(targetNode).outerHTML
    },
    style: {
      pointerEvents: "none"
    }
  }), React__default.createElement(TargetOverlay, {
    onClick: targetOnClick ? function(event) {
      return targetOnClick({
        event: event,
        target: target
      });
    } : void 0
  }));
}, DN50A = theme.colors.DN50A, DN60A = theme.colors.DN60A, N0 = theme.colors.N0, N50A = theme.colors.N50A, N60A = theme.colors.N60A, P300 = theme.colors.P300, dialogWidth = function(_ref) {
  var width = _ref.width;
  return "".concat(Math.min(Math.max(width, 160), 600), "px");
}, borderColor = theme.themed({
  light: N60A,
  dark: DN60A
}), shadowColor = theme.themed({
  light: N50A,
  dark: DN50A
}), boxShadow = function(props) {
  return [ "0 0 1px ".concat(borderColor(props)), "0 4px 8px -2px ".concat(shadowColor(props)) ].join(",");
}, FillScreen = styled__default.div.withConfig({
  displayName: "Dialog__FillScreen",
  componentId: "sc-1hoos68-0"
})([ "height:100%;left:0;overflow-y:auto;position:absolute;top:", "px;width:100%;" ], (function(p) {
  return p.scrollDistance;
})), Dialog = styled__default.div.withConfig({
  displayName: "Dialog",
  componentId: "sc-1hoos68-1"
})([ "background:", ";border-radius:", "px;box-shadow:", ";box-sizing:border-box;color:", ";display:flex;flex-direction:column;width:", ";" ], P300, theme.borderRadius, boxShadow, N0, dialogWidth), DialogBody = styled__default.div.withConfig({
  displayName: "Dialog__DialogBody",
  componentId: "sc-1hoos68-2"
})([ "flex:1 1 auto;padding:", "px ", "px ", "px;p:last-child,ul:last-child,ol:last-child{margin-bottom:0;}" ], theme.math.multiply(theme.gridSize, 2), theme.math.multiply(theme.gridSize, 3), theme.gridSize), Heading$1 = styled__default.h4.withConfig({
  displayName: "Dialog__Heading",
  componentId: "sc-1hoos68-3"
})([ "color:inherit;font-size:20px;font-style:inherit;font-weight:500;letter-spacing:-0.008em;line-height:1.2;margin-bottom:", "px;" ], theme.gridSize), Image$1 = styled__default.img.withConfig({
  displayName: "Dialog__Image",
  componentId: "sc-1hoos68-4"
})([ "height:auto;max-width:100%;" ]), Actions$1 = styled__default.div.withConfig({
  displayName: "Dialog__Actions",
  componentId: "sc-1hoos68-5"
})([ "display:flex;justify-content:space-between;padding:0 ", "px ", "px;" ], theme.math.multiply(theme.gridSize, 3), theme.math.multiply(theme.gridSize, 2)), ActionItems = styled__default.div.withConfig({
  displayName: "Dialog__ActionItems",
  componentId: "sc-1hoos68-6"
})([ "display:flex;margin:0 -", "px;" ], theme.math.divide(theme.gridSize, 2)), ActionItem$1 = styled__default.div.withConfig({
  displayName: "Dialog__ActionItem",
  componentId: "sc-1hoos68-7"
})([ "margin:0 ", "px;" ], theme.math.divide(theme.gridSize, 2)), pkg = {
  name: "@uidu/onboarding",
  version: "999.9.9",
  "NOTE: THIS FILE": "IS ONLY USED IN DEVELOPMENT",
  "BEFORE PUBLISH": "IT IS REGENERATED WITH ACTUAL VERSION INFO"
};

function _extends$1() {
  return (_extends$1 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
    }
    return target;
  }).apply(this, arguments);
}

function _objectWithoutProperties$2(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose$2(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

function _objectWithoutPropertiesLoose$2(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

var Container = styled__default.div.withConfig({
  displayName: "Card__Container",
  componentId: "mmch9t-0"
})([ "", ";" ], (function(_ref) {
  return _ref.theme;
})), Body$1 = styled__default.div.withConfig({
  displayName: "Card__Body",
  componentId: "mmch9t-1"
})([ "display:flex;flex-direction:column;padding:", "px ", "px;" ], theme.math.multiply(theme.gridSize, 2), theme.math.multiply(theme.gridSize, 2.5)), Heading$2 = styled__default.h4.withConfig({
  displayName: "Card__Heading",
  componentId: "mmch9t-2"
})([ "", ";color:inherit;" ], theme.typography.h600), DefaultHeader = styled__default.div.withConfig({
  displayName: "Card__DefaultHeader",
  componentId: "mmch9t-3"
})([ "display:flex;justify-content:space-between;align-items:baseline;padding-bottom:", "px;" ], theme.gridSize), DefaultFooter = styled__default.div.withConfig({
  displayName: "Card__DefaultFooter",
  componentId: "mmch9t-4"
})([ "display:flex;justify-content:space-between;align-items:center;padding-top:", "px;" ], theme.gridSize), Theme = theme.createTheme((function() {
  return {
    container: {
      overflow: "auto",
      borderRadius: "".concat(theme.borderRadius(), "px"),
      height: "fit-content",
      zIndex: "".concat(theme.layers.spotlight() + 1)
    }
  };
})), Card = function(_ref2) {
  var _ref2$actions = _ref2.actions, actions = void 0 === _ref2$actions ? [] : _ref2$actions, actionsBeforeElement = _ref2.actionsBeforeElement, children = _ref2.children, _ref2$components = _ref2.components, components = void 0 === _ref2$components ? {} : _ref2$components, image = _ref2.image, heading = _ref2.heading, headingAfterElement = _ref2.headingAfterElement, theme = _ref2.theme, innerRef = _ref2.innerRef, _components$Header = components.Header, Header = void 0 === _components$Header ? DefaultHeader : _components$Header, _components$Footer = components.Footer, Footer = void 0 === _components$Footer ? DefaultFooter : _components$Footer;
  return React__default.createElement(Theme.Provider, {
    value: theme
  }, React__default.createElement(Theme.Consumer, null, (function(_ref3) {
    var container = _ref3.container;
    return React__default.createElement(Container, {
      theme: container,
      ref: innerRef
    }, "string" == typeof image ? React__default.createElement("img", {
      src: image,
      alt: ""
    }) : image, React__default.createElement(Body$1, null, heading || headingAfterElement ? React__default.createElement(Header, null, React__default.createElement(Heading$2, null, heading), headingAfterElement || React__default.createElement("span", null)) : null, children, actions.length > 0 || actionsBeforeElement ? React__default.createElement(Footer, null, actionsBeforeElement || React__default.createElement("span", null), React__default.createElement(ActionItems, null, actions.map((function(_ref4, idx) {
      var text = _ref4.text, key = _ref4.key, rest = _objectWithoutProperties$2(_ref4, [ "text", "key" ]);
      return React__default.createElement(ActionItem$1, {
        key: key || ("string" == typeof text ? text : "".concat(idx))
      }, React__default.createElement(Button__default, rest, text));
    })))) : null));
  })));
}, Card$1 = React__default.forwardRef((function(props, ref) {
  return React__default.createElement(Card, _extends$1({}, props, {
    innerRef: ref
  }));
}));

function _extends$2() {
  return (_extends$2 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
    }
    return target;
  }).apply(this, arguments);
}

function _typeof$2(obj) {
  return (_typeof$2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function ownKeys$2(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$2(Object(source), !0).forEach((function(key) {
      _defineProperty$3(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$2(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

function _objectWithoutProperties$3(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose$3(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

function _objectWithoutPropertiesLoose$3(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

function _classCallCheck$1(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties$1(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$1(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties$1(Constructor.prototype, protoProps), staticProps && _defineProperties$1(Constructor, staticProps), 
  Constructor;
}

function _inherits$1(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf$1(subClass, superClass);
}

function _setPrototypeOf$1(o, p) {
  return (_setPrototypeOf$1 = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper$1(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$1();
  return function() {
    var result, Super = _getPrototypeOf$1(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$1(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn$1(this, result);
  };
}

function _possibleConstructorReturn$1(self, call) {
  return !call || "object" !== _typeof$2(call) && "function" != typeof call ? _assertThisInitialized$1(self) : call;
}

function _assertThisInitialized$1(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct$1() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf$1(o) {
  return (_getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

function _defineProperty$3(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

var N0$1 = theme.colors.N0, N50A$1 = theme.colors.N50A, N60A$1 = theme.colors.N60A, P300$1 = theme.colors.P300, SpotlightCard = function(_React$Component) {
  _inherits$1(SpotlightCard, React__default.Component);
  var _super = _createSuper$1(SpotlightCard);
  function SpotlightCard() {
    return _classCallCheck$1(this, SpotlightCard), _super.apply(this, arguments);
  }
  return _createClass$1(SpotlightCard, [ {
    key: "render",
    value: function() {
      var _this$props = this.props, actions = _this$props.actions, actionsBeforeElement = _this$props.actionsBeforeElement, children = _this$props.children, components = _this$props.components, isFlat = _this$props.isFlat, heading = _this$props.heading, headingAfterElement = _this$props.headingAfterElement, image = _this$props.image, innerRef = _this$props.innerRef, _theme = _this$props.theme, width = _this$props.width;
      return React__default.createElement(Button.Theme.Provider, {
        value: spotlightButtonTheme
      }, React__default.createElement(Card$1, {
        ref: innerRef,
        heading: heading,
        headingAfterElement: headingAfterElement,
        actions: actions,
        actionsBeforeElement: actionsBeforeElement,
        components: components,
        image: image,
        theme: function(parent) {
          var _parent = parent({}), container = _parent.container, others = _objectWithoutProperties$3(_parent, [ "container" ]);
          return _theme((function() {
            return _objectSpread$2(_objectSpread$2({}, others), {}, {
              container: _objectSpread$2({
                background: P300$1,
                color: N0$1,
                width: "".concat(Math.min(Math.max(width, 160), 600), "px"),
                boxShadow: isFlat ? void 0 : "0 4px 8px -2px ".concat(N50A$1, ", 0 0 1px ").concat(N60A$1)
              }, container)
            });
          }), {});
        }
      }, children));
    }
  } ]), SpotlightCard;
}();

_defineProperty$3(SpotlightCard, "defaultProps", {
  width: 400,
  isFlat: !1,
  components: {},
  theme: function(themeFn) {
    return themeFn();
  }
});

var SpotlightCard$1 = React__default.forwardRef((function(props, ref) {
  return React__default.createElement(SpotlightCard, _extends$2({}, props, {
    innerRef: ref
  }));
}));

function _typeof$3(obj) {
  return (_typeof$3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function _classCallCheck$2(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties$2(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$2(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties$2(Constructor.prototype, protoProps), staticProps && _defineProperties$2(Constructor, staticProps), 
  Constructor;
}

function _inherits$2(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf$2(subClass, superClass);
}

function _setPrototypeOf$2(o, p) {
  return (_setPrototypeOf$2 = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper$2(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$2();
  return function() {
    var result, Super = _getPrototypeOf$2(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$2(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn$2(this, result);
  };
}

function _possibleConstructorReturn$2(self, call) {
  return !call || "object" !== _typeof$3(call) && "function" != typeof call ? _assertThisInitialized$2(self) : call;
}

function _assertThisInitialized$2(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct$2() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf$2(o) {
  return (_getPrototypeOf$2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

var ValueChanged = function(_React$Component) {
  _inherits$2(ValueChanged, React__default.Component);
  var _super = _createSuper$2(ValueChanged);
  function ValueChanged() {
    return _classCallCheck$2(this, ValueChanged), _super.apply(this, arguments);
  }
  return _createClass$2(ValueChanged, [ {
    key: "componentDidUpdate",
    value: function(prevProps) {
      prevProps.value !== this.props.value && this.props.onChange();
    }
  }, {
    key: "render",
    value: function() {
      return this.props.children;
    }
  } ]), ValueChanged;
}();

function _typeof$4(obj) {
  return (_typeof$4 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function ownKeys$3(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$3(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$3(Object(source), !0).forEach((function(key) {
      _defineProperty$4(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$3(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

function _objectWithoutProperties$4(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose$4(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

function _objectWithoutPropertiesLoose$4(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

function _classCallCheck$3(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties$3(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$3(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties$3(Constructor.prototype, protoProps), staticProps && _defineProperties$3(Constructor, staticProps), 
  Constructor;
}

function _inherits$3(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf$3(subClass, superClass);
}

function _setPrototypeOf$3(o, p) {
  return (_setPrototypeOf$3 = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper$3(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$3();
  return function() {
    var result, Super = _getPrototypeOf$3(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$3(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn$3(this, result);
  };
}

function _possibleConstructorReturn$3(self, call) {
  return !call || "object" !== _typeof$4(call) && "function" != typeof call ? _assertThisInitialized$3(self) : call;
}

function _assertThisInitialized$3(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct$3() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf$3(o) {
  return (_getPrototypeOf$3 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

function _defineProperty$4(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

var SpotlightDialog = function(_Component) {
  _inherits$3(SpotlightDialog, React.Component);
  var _super = _createSuper$3(SpotlightDialog);
  function SpotlightDialog() {
    var _this;
    _classCallCheck$3(this, SpotlightDialog);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
    return _defineProperty$4(_assertThisInitialized$3(_this = _super.call.apply(_super, [ this ].concat(args))), "state", {
      focusLockDisabled: !0
    }), _this;
  }
  return _createClass$3(SpotlightDialog, [ {
    key: "componentDidMount",
    value: function() {
      var _this2 = this;
      setTimeout((function() {
        _this2.setState({
          focusLockDisabled: !1
        });
      }), 200);
    }
  }, {
    key: "render",
    value: function() {
      var _this$props = this.props, actions = _this$props.actions, actionsBeforeElement = _this$props.actionsBeforeElement, animationStyles = _this$props.animationStyles, children = _this$props.children, dialogPlacement = _this$props.dialogPlacement, dialogWidth = _this$props.dialogWidth, footer = _this$props.footer, header = _this$props.header, heading = _this$props.heading, image = _this$props.image, targetNode = _this$props.targetNode, focusLockDisabled = this.state.focusLockDisabled, translatedPlacement = dialogPlacement ? {
        "top left": "top-start",
        "top center": "top",
        "top right": "top-end",
        "right top": "right-start",
        "right middle": "right",
        "right bottom": "right-end",
        "bottom left": "bottom-start",
        "bottom center": "bottom",
        "bottom right": "bottom-end",
        "left top": "left-start",
        "left middle": "left",
        "left bottom": "left-end"
      }[dialogPlacement] : void 0;
      return React__default.createElement(popper.Popper, {
        referenceElement: targetNode,
        placement: translatedPlacement
      }, (function(_ref) {
        var ref = _ref.ref, style = _ref.style, update = _ref.update;
        return React__default.createElement(ValueChanged, {
          value: dialogWidth,
          onChange: update
        }, React__default.createElement(FocusLock, {
          disabled: focusLockDisabled,
          returnFocus: !1,
          autoFocus: !0
        }, React__default.createElement(SpotlightCard$1, {
          ref: ref,
          theme: function(parent) {
            var _parent = parent({}), container = _parent.container;
            return _objectSpread$3(_objectSpread$3({}, _objectWithoutProperties$4(_parent, [ "container" ])), {}, {
              container: _objectSpread$3(_objectSpread$3(_objectSpread$3({}, container), style), animationStyles)
            });
          },
          width: dialogWidth,
          actions: actions,
          actionsBeforeElement: actionsBeforeElement,
          image: image && React__default.createElement(Image$1, {
            alt: heading,
            src: image
          }),
          components: {
            Header: header,
            Footer: footer
          },
          heading: heading
        }, children)));
      }));
    }
  } ]), SpotlightDialog;
}(), createAndFireEventOnAtlaskit = analytics.createAndFireEvent("atlaskit"), SpotlightDialog$1 = analytics.withAnalyticsContext({
  componentName: "spotlight",
  packageName: pkg.name,
  packageVersion: pkg.version
})(analytics.withAnalyticsEvents({
  targetOnClick: createAndFireEventOnAtlaskit({
    action: "clicked",
    actionSubject: "spotlight",
    attributes: {
      componentName: "spotlight",
      packageName: pkg.name,
      packageVersion: pkg.version
    }
  })
})(SpotlightDialog));

function _typeof$5(obj) {
  return (_typeof$5 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function _classCallCheck$4(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties$4(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$4(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties$4(Constructor.prototype, protoProps), staticProps && _defineProperties$4(Constructor, staticProps), 
  Constructor;
}

function _inherits$4(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf$4(subClass, superClass);
}

function _setPrototypeOf$4(o, p) {
  return (_setPrototypeOf$4 = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper$4(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$4();
  return function() {
    var result, Super = _getPrototypeOf$4(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$4(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn$4(this, result);
  };
}

function _possibleConstructorReturn$4(self, call) {
  return !call || "object" !== _typeof$5(call) && "function" != typeof call ? _assertThisInitialized$4(self) : call;
}

function _assertThisInitialized$4(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct$4() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf$4(o) {
  return (_getPrototypeOf$4 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

function _defineProperty$5(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

var TransitionContext = React.createContext({
  isOpen: !0,
  onExited: function() {}
}), hasChildren = function(children) {
  return React__default.Children.count(children) > 0 && React__default.Children.map(children, (function(child) {
    return !!child;
  })).filter(Boolean).length > 0;
}, Transition = function(_React$Component) {
  _inherits$4(Transition, React__default.Component);
  var _super = _createSuper$4(Transition);
  function Transition() {
    var _this;
    _classCallCheck$4(this, Transition);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
    return _defineProperty$5(_assertThisInitialized$4(_this = _super.call.apply(_super, [ this ].concat(args))), "state", {
      currentChildren: void 0
    }), _defineProperty$5(_assertThisInitialized$4(_this), "onExited", (function() {
      _this.setState({
        currentChildren: _this.props.children
      });
    })), _this;
  }
  return _createClass$4(Transition, [ {
    key: "render",
    value: function() {
      return React__default.createElement(TransitionContext.Provider, {
        value: {
          onExited: this.onExited,
          isOpen: hasChildren(this.props.children)
        }
      }, this.state.currentChildren);
    }
  } ], [ {
    key: "getDerivedStateFromProps",
    value: function(props, state) {
      var previousChildren = state.currentChildren;
      return {
        currentChildren: hasChildren(previousChildren) && !hasChildren(props.children) ? previousChildren : props.children
      };
    }
  } ]), Transition;
}(), SpotlightTransitionConsumer = TransitionContext.Consumer;

function _typeof$6(obj) {
  return (_typeof$6 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function _classCallCheck$5(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties$5(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$5(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties$5(Constructor.prototype, protoProps), staticProps && _defineProperties$5(Constructor, staticProps), 
  Constructor;
}

function _inherits$5(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf$5(subClass, superClass);
}

function _setPrototypeOf$5(o, p) {
  return (_setPrototypeOf$5 = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper$5(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$5();
  return function() {
    var result, Super = _getPrototypeOf$5(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$5(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn$5(this, result);
  };
}

function _possibleConstructorReturn$5(self, call) {
  return !call || "object" !== _typeof$6(call) && "function" != typeof call ? _assertThisInitialized$5(self) : call;
}

function _assertThisInitialized$5(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct$5() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf$5(o) {
  return (_getPrototypeOf$5 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

function _defineProperty$6(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

var SpotlightInner = function(_React$Component) {
  _inherits$5(SpotlightInner, React__default.Component);
  var _super = _createSuper$5(SpotlightInner);
  function SpotlightInner() {
    var _this;
    _classCallCheck$5(this, SpotlightInner);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
    return _defineProperty$6(_assertThisInitialized$5(_this = _super.call.apply(_super, [ this ].concat(args))), "state", {
      replacementElement: null
    }), _defineProperty$6(_assertThisInitialized$5(_this), "isPositionFixed", (function(element) {
      return "fixed" === window.getComputedStyle(element).position;
    })), _defineProperty$6(_assertThisInitialized$5(_this), "hasPositionFixedParent", (function(element) {
      var offsetParent = element.offsetParent;
      return !!offsetParent && (!!_this.isPositionFixed(offsetParent) || _this.hasPositionFixedParent(offsetParent));
    })), _defineProperty$6(_assertThisInitialized$5(_this), "getTargetNodeStyle", (function() {
      if (!exenv.canUseDOM) return {};
      var targetNode = _this.props.targetNode, _targetNode$getBoundi = targetNode.getBoundingClientRect(), height = _targetNode$getBoundi.height, left = _targetNode$getBoundi.left, top = _targetNode$getBoundi.top, width = _targetNode$getBoundi.width;
      return _this.isPositionFixed(targetNode) || _this.hasPositionFixedParent(targetNode) ? {
        height: height,
        left: left,
        top: top,
        width: width,
        position: "fixed"
      } : {
        height: height,
        left: left + window.pageXOffset,
        top: top + window.pageYOffset,
        width: width,
        position: "absolute"
      };
    })), _this;
  }
  return _createClass$5(SpotlightInner, [ {
    key: "componentDidUpdate",
    value: function(prevProps) {
      prevProps.targetNode !== this.props.targetNode && scrollIntoView(this.props.targetNode, {
        scrollMode: "if-needed"
      });
    }
  }, {
    key: "componentDidMount",
    value: function() {
      scrollIntoView(this.props.targetNode, {
        scrollMode: "if-needed"
      }), this.props.onOpened();
    }
  }, {
    key: "componentWillUnmount",
    value: function() {
      this.props.onClosed();
    }
  }, {
    key: "render",
    value: function() {
      var _this2 = this, _this$props = this.props, pulse = _this$props.pulse, target = _this$props.target, targetNode = _this$props.targetNode, targetBgColor = _this$props.targetBgColor, targetOnClick = _this$props.targetOnClick, targetRadius = _this$props.targetRadius, TargetReplacement = _this$props.targetReplacement, replacementElement = this.state.replacementElement;
      return React__default.createElement(SpotlightTransitionConsumer, null, (function(_ref) {
        var isOpen = _ref.isOpen, onExited = _ref.onExited;
        return React__default.createElement(Portal, {
          zIndex: theme.layers.spotlight() + 1
        }, TargetReplacement ? React__default.createElement(NodeResovler, {
          innerRef: function(elem) {
            return _this2.setState({
              replacementElement: elem
            });
          }
        }, React__default.createElement(TargetReplacement, _this2.getTargetNodeStyle())) : React__default.createElement(Clone, {
          pulse: pulse,
          target: target,
          style: _this2.getTargetNodeStyle(),
          targetBgColor: targetBgColor,
          targetNode: targetNode,
          targetOnClick: targetOnClick,
          targetRadius: targetRadius
        }), TargetReplacement && !replacementElement ? null : React__default.createElement(Fade, {
          in: isOpen,
          onExited: onExited
        }, (function(animationStyles) {
          return React__default.createElement(SpotlightDialog$1, {
            actions: _this2.props.actions,
            actionsBeforeElement: _this2.props.actionsBeforeElement,
            children: _this2.props.children,
            dialogPlacement: _this2.props.dialogPlacement,
            dialogWidth: _this2.props.dialogWidth,
            footer: _this2.props.footer,
            header: _this2.props.header,
            heading: _this2.props.heading,
            image: _this2.props.image,
            targetNode: replacementElement || targetNode,
            animationStyles: animationStyles
          });
        })), React__default.createElement(ScrollLock, null));
      }));
    }
  } ]), SpotlightInner;
}();

_defineProperty$6(SpotlightInner, "defaultProps", {
  dialogWidth: 400,
  pulse: !0
});

var backgroundColor = theme.themed({
  light: theme.colors.N100A,
  dark: theme.colors.DN90A
}), Blanket = styled__default.div.withConfig({
  displayName: "Blanket",
  componentId: "sc-1wmlblc-0"
})([ "background:", ";bottom:0;left:0;position:fixed;right:0;top:0;transition:opacity 220ms;z-index:", ";" ], (function(p) {
  return p.isTinted ? backgroundColor : "transparent";
}), theme.layers.spotlight);

function _typeof$7(obj) {
  return (_typeof$7 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function ownKeys$4(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$4(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$4(Object(source), !0).forEach((function(key) {
      _defineProperty$7(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$4(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

function _classCallCheck$6(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties$6(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$6(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties$6(Constructor.prototype, protoProps), staticProps && _defineProperties$6(Constructor, staticProps), 
  Constructor;
}

function _inherits$6(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf$6(subClass, superClass);
}

function _setPrototypeOf$6(o, p) {
  return (_setPrototypeOf$6 = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper$6(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$6();
  return function() {
    var result, Super = _getPrototypeOf$6(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$6(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn$6(this, result);
  };
}

function _possibleConstructorReturn$6(self, call) {
  return !call || "object" !== _typeof$7(call) && "function" != typeof call ? _assertThisInitialized$6(self) : call;
}

function _assertThisInitialized$6(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct$6() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf$6(o) {
  return (_getPrototypeOf$6 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

function _defineProperty$7(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

var noop$1 = function() {}, _createContext = React.createContext(void 0), TargetConsumer = _createContext.Consumer, TargetProvider = _createContext.Provider, _createContext2 = React.createContext({
  opened: noop$1,
  closed: noop$1,
  targets: {}
}), SpotlightStateConsumer = _createContext2.Consumer, SpotlightStateProvider = _createContext2.Provider, Container$1 = function(_ref) {
  var Wrapper = _ref.component, children = _ref.children;
  return React__default.createElement(Wrapper, null, children);
}, SpotlightManager = function(_PureComponent) {
  _inherits$6(SpotlightManager, React.PureComponent);
  var _super = _createSuper$6(SpotlightManager);
  function SpotlightManager() {
    var _this;
    _classCallCheck$6(this, SpotlightManager);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
    return _defineProperty$7(_assertThisInitialized$6(_this = _super.call.apply(_super, [ this ].concat(args))), "state", {
      spotlightCount: 0,
      targets: {}
    }), _defineProperty$7(_assertThisInitialized$6(_this), "targetRef", (function(name) {
      return function(element) {
        _this.setState((function(state) {
          return {
            targets: _objectSpread$4(_objectSpread$4({}, state.targets), {}, _defineProperty$7({}, name, element || void 0))
          };
        }));
      };
    })), _defineProperty$7(_assertThisInitialized$6(_this), "spotlightOpen", (function() {
      _this.setState((function(state) {
        return {
          spotlightCount: state.spotlightCount + 1
        };
      }));
    })), _defineProperty$7(_assertThisInitialized$6(_this), "spotlightClose", (function() {
      _this.setState((function(state) {
        return {
          spotlightCount: state.spotlightCount - 1
        };
      }));
    })), _defineProperty$7(_assertThisInitialized$6(_this), "getStateProviderValue", memoizeOne((function(targets) {
      return {
        opened: _this.spotlightOpen,
        closed: _this.spotlightClose,
        targets: targets
      };
    }))), _this;
  }
  return _createClass$6(SpotlightManager, [ {
    key: "componentDidMount",
    value: function() {}
  }, {
    key: "render",
    value: function() {
      var _this$props = this.props, blanketIsTinted = _this$props.blanketIsTinted, children = _this$props.children, Tag = _this$props.component;
      return React__default.createElement(SpotlightStateProvider, {
        value: this.getStateProviderValue(this.state.targets)
      }, React__default.createElement(TargetProvider, {
        value: this.targetRef
      }, React__default.createElement(Container$1, {
        component: Tag || React__default.Fragment
      }, React__default.createElement(Fade, {
        in: this.state.spotlightCount > 0
      }, (function(animationStyles) {
        return React__default.createElement(Portal, {
          zIndex: theme.layers.spotlight()
        }, React__default.createElement(Blanket, {
          style: animationStyles,
          isTinted: blanketIsTinted
        }));
      })), children)));
    }
  } ]), SpotlightManager;
}();

function _typeof$8(obj) {
  return (_typeof$8 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function _extends$3() {
  return (_extends$3 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
    }
    return target;
  }).apply(this, arguments);
}

function _objectWithoutProperties$5(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose$5(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

function _objectWithoutPropertiesLoose$5(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

function _classCallCheck$7(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties$7(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$7(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties$7(Constructor.prototype, protoProps), staticProps && _defineProperties$7(Constructor, staticProps), 
  Constructor;
}

function _inherits$7(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf$7(subClass, superClass);
}

function _setPrototypeOf$7(o, p) {
  return (_setPrototypeOf$7 = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper$7(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$7();
  return function() {
    var result, Super = _getPrototypeOf$7(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$7(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn$7(this, result);
  };
}

function _possibleConstructorReturn$7(self, call) {
  return !call || "object" !== _typeof$8(call) && "function" != typeof call ? _assertThisInitialized$7(self) : call;
}

function _assertThisInitialized$7(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct$7() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf$7(o) {
  return (_getPrototypeOf$7 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

function _defineProperty$8(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

_defineProperty$7(SpotlightManager, "defaultProps", {
  blanketIsTinted: !0
});

var Spotlight = function(_React$Component) {
  _inherits$7(Spotlight, React__default.Component);
  var _super = _createSuper$7(Spotlight);
  function Spotlight() {
    return _classCallCheck$7(this, Spotlight), _super.apply(this, arguments);
  }
  return _createClass$7(Spotlight, [ {
    key: "render",
    value: function() {
      var _this$props = this.props, targetNode = _this$props.targetNode, target = _this$props.target, rest = _objectWithoutProperties$5(_this$props, [ "targetNode", "target" ]);
      return React__default.createElement(SpotlightStateConsumer, null, (function(_ref) {
        var opened = _ref.opened, closed = _ref.closed, targets = _ref.targets, actualTargetNode = targetNode || ("string" == typeof target ? targets[target] : void 0);
        return actualTargetNode ? React__default.createElement(SpotlightInner, _extends$3({}, rest, {
          targetNode: actualTargetNode,
          target: target,
          onOpened: opened,
          onClosed: closed
        })) : null;
      }));
    }
  } ]), Spotlight;
}();

function _typeof$9(obj) {
  return (_typeof$9 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function _classCallCheck$8(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties$8(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass$8(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties$8(Constructor.prototype, protoProps), staticProps && _defineProperties$8(Constructor, staticProps), 
  Constructor;
}

function _inherits$8(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf$8(subClass, superClass);
}

function _setPrototypeOf$8(o, p) {
  return (_setPrototypeOf$8 = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper$8(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$8();
  return function() {
    var result, Super = _getPrototypeOf$8(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$8(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn$8(this, result);
  };
}

function _possibleConstructorReturn$8(self, call) {
  return !call || "object" !== _typeof$9(call) && "function" != typeof call ? _assertThisInitialized$8(self) : call;
}

function _assertThisInitialized$8(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct$8() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf$8(o) {
  return (_getPrototypeOf$8 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

_defineProperty$8(Spotlight, "defaultProps", {
  dialogWidth: 400,
  pulse: !0
});

var SpotlightTarget = function(_Component) {
  _inherits$8(SpotlightTarget, React.Component);
  var _super = _createSuper$8(SpotlightTarget);
  function SpotlightTarget() {
    return _classCallCheck$8(this, SpotlightTarget), _super.apply(this, arguments);
  }
  return _createClass$8(SpotlightTarget, [ {
    key: "render",
    value: function() {
      var _this = this;
      return React__default.createElement(TargetConsumer, null, (function(targetRef) {
        return targetRef ? React__default.createElement(NodeResovler, {
          innerRef: targetRef(_this.props.name)
        }, _this.props.children) : _this.props.children;
      }));
    }
  } ]), SpotlightTarget;
}();

exports.Modal = OnboardingModal, exports.Spotlight = Spotlight, exports.SpotlightCard = SpotlightCard$1, 
exports.SpotlightManager = SpotlightManager, exports.SpotlightPulse = Pulse, exports.SpotlightTarget = SpotlightTarget, 
exports.SpotlightTransition = Transition;
