import Button, { Theme as Theme$1 } from '@uidu/button';
import Modal from '@uidu/modal-dialog';
import React, { Component, createContext, PureComponent } from 'react';
import { gridSize, borderRadius } from '@uidu/theme/constants';
import { divide } from '@uidu/theme/math';
import styled, { keyframes, css } from 'styled-components';
import { colors, layers, themed, borderRadius as borderRadius$1, math, gridSize as gridSize$1, typography, createTheme } from '@uidu/theme';
import Portal from '@uidu/portal';
import { canUseDOM } from 'exenv';
import NodeResovler from 'react-node-resolver';
import ScrollLock from 'react-scrolllock';
import scrollIntoView from 'scroll-into-view-if-needed';
import { Transition as Transition$1 } from 'react-transition-group';
import { withAnalyticsContext, withAnalyticsEvents, createAndFireEvent } from '@uidu/analytics';
import { Popper } from '@uidu/popper';
import FocusLock from 'react-focus-lock';
import memoizeOne from 'memoize-one';

var Body = styled.div.withConfig({
  displayName: "Modal__Body",
  componentId: "sc-164q298-0"
})(["padding:40px 20px;text-align:center;"]);
var Heading = styled.h4.withConfig({
  displayName: "Modal__Heading",
  componentId: "sc-164q298-1"
})(["color:inherit;font-size:20px;font-style:inherit;font-weight:500;letter-spacing:-0.008em;line-height:1.2;margin-bottom:", "px;"], gridSize);
var Image = styled.img.withConfig({
  displayName: "Modal__Image",
  componentId: "sc-164q298-2"
})(["border-top-left-radius:", "px;border-top-right-radius:", "px;height:auto;width:100%;@media (min-width:320px) and (max-width:480px){border-radius:0;}"], borderRadius, borderRadius);
var actionItemBottomMargin = gridSize() / 2;
var Actions = styled.div.withConfig({
  displayName: "Modal__Actions",
  componentId: "sc-164q298-3"
})(["display:flex;justify-content:center;padding:0 40px ", "px;flex-flow:wrap;flex-direction:", ";"], 40 - actionItemBottomMargin, function (_ref) {
  var shouldReverseButtonOrder = _ref.shouldReverseButtonOrder;
  return shouldReverseButtonOrder ? 'row-reverse' : 'normal';
});
var ActionItem = styled.div.withConfig({
  displayName: "Modal__ActionItem",
  componentId: "sc-164q298-4"
})(["margin:0 ", "px ", "px;"], divide(gridSize, 2), actionItemBottomMargin);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }
var spotlightTheme = {
  "default": {
    background: {
      "default": {
        light: colors.P400,
        dark: colors.P400
      },
      hover: {
        light: colors.P200,
        dark: colors.P200
      },
      active: {
        light: colors.P500,
        dark: colors.P500
      },
      disabled: {
        light: colors.N30,
        dark: colors.DN70
      },
      selected: {
        light: colors.R500,
        dark: colors.R500
      },
      focus: {
        light: colors.P400,
        dark: colors.P400
      }
    },
    boxShadow: {
      focus: {
        light: "".concat(colors.P100, " 0 0 0 2px"),
        dark: "".concat(colors.P100, " 0 0 0 2px")
      }
    },
    color: {
      "default": {
        light: colors.N0,
        dark: colors.N0
      },
      hover: {
        light: colors.N0,
        dark: colors.N0
      },
      active: {
        light: colors.N0,
        dark: colors.N0
      },
      disabled: {
        light: colors.N0,
        dark: colors.DN30
      },
      selected: {
        light: colors.N0,
        dark: colors.N0
      },
      focus: {
        light: colors.N0,
        dark: colors.N0
      }
    },
    outline: {
      focus: {
        light: 'none',
        dark: 'none'
      }
    }
  },
  'subtle-link': {
    textDecoration: {
      hover: {
        light: "underline ".concat(colors.P75),
        dark: "underline ".concat(colors.P75)
      }
    },
    textDecorationLine: {
      active: {
        light: 'none',
        dark: 'none'
      }
    },
    boxShadow: {
      focus: {
        light: "".concat(colors.P100, " 0 0 0 2px"),
        dark: "".concat(colors.P100, " 0 0 0 2px")
      }
    },
    color: {
      "default": {
        light: colors.N0,
        dark: colors.N0
      },
      hover: {
        light: colors.P75,
        dark: colors.P75
      },
      active: {
        light: colors.P100,
        dark: colors.P100
      },
      disabled: {
        light: colors.P500,
        dark: colors.P500
      },
      selected: {
        light: colors.N0,
        dark: colors.N0
      }
    }
  }
};
var modalTheme = {
  primary: {
    background: {
      "default": {
        light: colors.P400,
        dark: colors.P400
      },
      hover: {
        light: colors.P200,
        dark: colors.P200
      },
      active: {
        light: colors.P500,
        dark: colors.P500
      },
      disabled: {
        light: colors.N30,
        dark: colors.DN70
      },
      selected: {
        light: colors.R500,
        dark: colors.R500
      },
      focus: {
        light: colors.P400,
        dark: colors.P400
      }
    },
    boxShadow: {
      focus: {
        light: "".concat(colors.P100, " 0 0 0 2px"),
        dark: "".concat(colors.P100, " 0 0 0 2px")
      }
    },
    color: {
      "default": {
        light: colors.N0,
        dark: colors.N0
      },
      disabled: {
        light: colors.N0,
        dark: colors.DN30
      },
      selected: {
        light: colors.N0,
        dark: colors.N0
      },
      focus: {
        light: colors.N0,
        dark: colors.N0
      }
    }
  }
};

function extract(newTheme, _ref) {
  var mode = _ref.mode,
      appearance = _ref.appearance,
      state = _ref.state;

  if (!newTheme[appearance]) {
    return undefined;
  }

  var root = newTheme[appearance];
  return Object.keys(root).reduce(function (acc, val) {
    var node = root;
    [val, state, mode].forEach(function (item) {
      if (!node[item]) {
        return undefined;
      }

      if (_typeof(node[item]) !== 'object') {
        acc[val] = node[item];
        return undefined;
      }

      node = node[item];
      return undefined;
    });
    return acc;
  }, {});
}

var spotlightButtonTheme = function spotlightButtonTheme(current, themeProps) {
  var _current = current(themeProps),
      buttonStyles = _current.buttonStyles,
      rest = _objectWithoutProperties(_current, ["buttonStyles"]);

  return _objectSpread({
    buttonStyles: _objectSpread(_objectSpread({}, buttonStyles), extract(spotlightTheme, themeProps))
  }, rest);
};
var modalButtonTheme = function modalButtonTheme(current, themeProps) {
  var _current2 = current(themeProps),
      buttonStyles = _current2.buttonStyles,
      rest = _objectWithoutProperties(_current2, ["buttonStyles"]);

  return _objectSpread({
    buttonStyles: _objectSpread(_objectSpread({}, buttonStyles), extract(modalTheme, themeProps))
  }, rest);
};

function _typeof$1(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$1 = function _typeof(obj) { return typeof obj; }; } else { _typeof$1 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$1(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties$1(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$1(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$1(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof$1(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function noop() {}

var OnboardingModal = /*#__PURE__*/function (_Component) {
  _inherits(OnboardingModal, _Component);

  var _super = _createSuper(OnboardingModal);

  function OnboardingModal() {
    var _this;

    _classCallCheck(this, OnboardingModal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty$1(_assertThisInitialized(_this), "headerComponent", function (props) {
      var HeaderElement = props.header,
          src = props.image;

      var ImageElement = function ImageElement() {
        return /*#__PURE__*/React.createElement(Image, {
          alt: "",
          src: src
        });
      };

      return HeaderElement || ImageElement;
    });

    _defineProperty$1(_assertThisInitialized(_this), "footerComponent", function (props) {
      var FooterElement = props.footer,
          actionList = props.actions,
          _props$experimental_s = props.experimental_shouldShowPrimaryButtonOnRight,
          experimental_shouldShowPrimaryButtonOnRight = _props$experimental_s === void 0 ? false : _props$experimental_s;

      var ActionsElement = function ActionsElement() {
        return actionList ? /*#__PURE__*/React.createElement(Theme$1.Provider, {
          value: modalButtonTheme
        }, /*#__PURE__*/React.createElement(Actions, {
          shouldReverseButtonOrder: experimental_shouldShowPrimaryButtonOnRight
        }, actionList.map(function (_ref, idx) {
          var text = _ref.text,
              key = _ref.key,
              rest = _objectWithoutProperties$1(_ref, ["text", "key"]);

          var variant = idx ? 'subtle-link' : 'primary';
          return /*#__PURE__*/React.createElement(ActionItem, {
            key: key || (typeof text === 'string' ? text : "".concat(idx))
          }, /*#__PURE__*/React.createElement(Button, _extends({
            appearance: variant,
            autoFocus: !idx
          }, rest), text));
        }))) : null;
      };

      return FooterElement || ActionsElement;
    });

    return _this;
  }

  _createClass(OnboardingModal, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          actions = _this$props.actions,
          children = _this$props.children,
          heading = _this$props.heading,
          props = _objectWithoutProperties$1(_this$props, ["actions", "children", "heading"]);

      return /*#__PURE__*/React.createElement(Modal, _extends({
        autoFocus: true,
        components: {
          Header: this.headerComponent(this.props),
          Footer: this.footerComponent(this.props)
        },
        onClose: noop,
        scrollBehavior: "outside",
        shouldCloseOnOverlayClick: false,
        shouldCloseOnEscapePress: false
      }, props), /*#__PURE__*/React.createElement(Body, null, heading && /*#__PURE__*/React.createElement(Heading, null, heading), children));
    }
  }]);

  return OnboardingModal;
}(Component);

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty$2(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$2(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var duration = 100;
var Fade = function Fade(_ref) {
  var hasEntered = _ref["in"],
      children = _ref.children,
      onExited = _ref.onExited;
  return /*#__PURE__*/React.createElement(Transition$1, {
    "in": hasEntered,
    timeout: duration,
    onExited: onExited,
    unmountOnExit: true,
    appear: true
  }, function (status) {
    var base = {
      transition: "opacity ".concat(duration, "ms"),
      opacity: 0
    };
    var anim = {
      entered: {
        opacity: 1
      },
      exiting: {
        opacity: 0
      }
    };

    var style = _objectSpread$1(_objectSpread$1({}, base), anim[status]);

    return children(style);
  });
};

// NOTE:
// Pulse color "rgb(101, 84, 192)" derived from "colors.P300"
var baseShadow = "0 0 0 2px ".concat(colors.P300);
var easing = 'cubic-bezier(0.55, 0.055, 0.675, 0.19)';
var pulseKeframes = keyframes(["0%,33%{box-shadow:", ",0 0 0 rgba(101,84,192,1)}66%,100%{box-shadow:", ",0 0 0 10px rgba(101,84,192,0.01)}"], baseShadow, baseShadow);
var animation = css(["animation:", " 3000ms ", " infinite;"], pulseKeframes, easing); // IE11 and Edge: z-index needed because fixed position calculates z-index relative
// to body instead of nearest stacking context (Portal in our case).

var Div = styled.div.withConfig({
  displayName: "Target__Div",
  componentId: "sc-69iyv5-0"
})(["z-index:", ";", " ", ""], layers.spotlight() + 1, function (p) {
  return p.bgColor ? "background-color: ".concat(p.bgColor, ";") : null;
}, function (p) {
  return p.radius ? "border-radius: ".concat(p.radius, "px;") : null;
});
var TargetInner = styled(Div).withConfig({
  displayName: "Target__TargetInner",
  componentId: "sc-69iyv5-1"
})(["", ";"], function (_ref) {
  var pulse = _ref.pulse;
  return pulse ? animation : null;
});
var TargetOverlay = styled.div.withConfig({
  displayName: "Target__TargetOverlay",
  componentId: "sc-69iyv5-2"
})(["cursor:", ";height:100%;left:0;position:absolute;top:0;width:100%;"], function (p) {
  return p.onClick ? 'pointer' : 'auto';
}); // exported for consumer

var Pulse = styled(Div).withConfig({
  displayName: "Target__Pulse",
  componentId: "sc-69iyv5-3"
})(["position:absolute;", ";"], animation);

function cloneAndOverrideStyles(node) {
  var shouldCloneChildren = true;
  var clonedNode = node.cloneNode(shouldCloneChildren);
  clonedNode.style.margin = '0';
  clonedNode.style.position = 'static'; // The target may have other transforms applied. Avoid unintended side effects
  // by zeroing out "translate" rather than applying a value of "none".

  clonedNode.style.transform = 'translate(0, 0) translate3d(0, 0, 0)';
  return clonedNode;
}

var Clone = function Clone(props) {
  var pulse = props.pulse,
      style = props.style,
      target = props.target,
      targetBgColor = props.targetBgColor,
      targetOnClick = props.targetOnClick,
      targetNode = props.targetNode,
      targetRadius = props.targetRadius;
  return /*#__PURE__*/React.createElement(TargetInner, {
    pulse: pulse,
    bgColor: targetBgColor,
    radius: targetRadius,
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    // eslint-disable-next-line react/no-danger
    dangerouslySetInnerHTML: {
      __html: cloneAndOverrideStyles(targetNode).outerHTML
    },
    style: {
      pointerEvents: 'none'
    }
  }), /*#__PURE__*/React.createElement(TargetOverlay, {
    onClick: targetOnClick ? function (event) {
      return targetOnClick({
        event: event,
        target: target
      });
    } : undefined
  }));
};

var DN50A = colors.DN50A,
    DN60A = colors.DN60A,
    N0 = colors.N0,
    N50A = colors.N50A,
    N60A = colors.N60A,
    P300 = colors.P300; // dialog may not be smaller than 160px or larger than 600px

var dialogWidth = function dialogWidth(_ref) {
  var width = _ref.width;
  return "".concat(Math.min(Math.max(width, 160), 600), "px");
};

var borderColor = themed({
  light: N60A,
  dark: DN60A
});
var shadowColor = themed({
  light: N50A,
  dark: DN50A
});

var boxShadow = function boxShadow(props) {
  var border = "0 0 1px ".concat(borderColor(props));
  var shadow = "0 4px 8px -2px ".concat(shadowColor(props));
  return [border, shadow].join(',');
};

var FillScreen = styled.div.withConfig({
  displayName: "Dialog__FillScreen",
  componentId: "sc-1hoos68-0"
})(["height:100%;left:0;overflow-y:auto;position:absolute;top:", "px;width:100%;"], function (p) {
  return p.scrollDistance;
});
var Dialog = styled.div.withConfig({
  displayName: "Dialog",
  componentId: "sc-1hoos68-1"
})(["background:", ";border-radius:", "px;box-shadow:", ";box-sizing:border-box;color:", ";display:flex;flex-direction:column;width:", ";"], P300, borderRadius$1, boxShadow, N0, dialogWidth);
var DialogBody = styled.div.withConfig({
  displayName: "Dialog__DialogBody",
  componentId: "sc-1hoos68-2"
})(["flex:1 1 auto;padding:", "px ", "px ", "px;p:last-child,ul:last-child,ol:last-child{margin-bottom:0;}"], math.multiply(gridSize$1, 2), math.multiply(gridSize$1, 3), gridSize$1); // internal elements

var Heading$1 = styled.h4.withConfig({
  displayName: "Dialog__Heading",
  componentId: "sc-1hoos68-3"
})(["color:inherit;font-size:20px;font-style:inherit;font-weight:500;letter-spacing:-0.008em;line-height:1.2;margin-bottom:", "px;"], gridSize$1);
var Image$1 = styled.img.withConfig({
  displayName: "Dialog__Image",
  componentId: "sc-1hoos68-4"
})(["height:auto;max-width:100%;"]); // actions

var Actions$1 = styled.div.withConfig({
  displayName: "Dialog__Actions",
  componentId: "sc-1hoos68-5"
})(["display:flex;justify-content:space-between;padding:0 ", "px ", "px;"], math.multiply(gridSize$1, 3), math.multiply(gridSize$1, 2));
var ActionItems = styled.div.withConfig({
  displayName: "Dialog__ActionItems",
  componentId: "sc-1hoos68-6"
})(["display:flex;margin:0 -", "px;"], math.divide(gridSize$1, 2));
var ActionItem$1 = styled.div.withConfig({
  displayName: "Dialog__ActionItem",
  componentId: "sc-1hoos68-7"
})(["margin:0 ", "px;"], math.divide(gridSize$1, 2));

var pkg = {
	name: "@uidu/onboarding",
	version: "999.9.9",
	"NOTE: THIS FILE": "IS ONLY USED IN DEVELOPMENT",
	"BEFORE PUBLISH": "IT IS REGENERATED WITH ACTUAL VERSION INFO"
};

function _extends$1() { _extends$1 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends$1.apply(this, arguments); }

function _objectWithoutProperties$2(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$2(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$2(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var Container = styled.div.withConfig({
  displayName: "Card__Container",
  componentId: "mmch9t-0"
})(["", ";"], function (_ref) {
  var theme = _ref.theme;
  return theme;
});
var Body$1 = styled.div.withConfig({
  displayName: "Card__Body",
  componentId: "mmch9t-1"
})(["display:flex;flex-direction:column;padding:", "px ", "px;"], math.multiply(gridSize$1, 2), math.multiply(gridSize$1, 2.5));
var Heading$2 = styled.h4.withConfig({
  displayName: "Card__Heading",
  componentId: "mmch9t-2"
})(["", ";color:inherit;"], typography.h600);
var DefaultHeader = styled.div.withConfig({
  displayName: "Card__DefaultHeader",
  componentId: "mmch9t-3"
})(["display:flex;justify-content:space-between;align-items:baseline;padding-bottom:", "px;"], gridSize$1);
var DefaultFooter = styled.div.withConfig({
  displayName: "Card__DefaultFooter",
  componentId: "mmch9t-4"
})(["display:flex;justify-content:space-between;align-items:center;padding-top:", "px;"], gridSize$1);
var Theme = createTheme(function () {
  return {
    container: {
      overflow: 'auto',
      borderRadius: "".concat(borderRadius$1(), "px"),
      height: 'fit-content',
      zIndex: "".concat(layers.spotlight() + 1)
    }
  };
});

var Card = function Card(_ref2) {
  var _ref2$actions = _ref2.actions,
      actions = _ref2$actions === void 0 ? [] : _ref2$actions,
      actionsBeforeElement = _ref2.actionsBeforeElement,
      children = _ref2.children,
      _ref2$components = _ref2.components,
      components = _ref2$components === void 0 ? {} : _ref2$components,
      image = _ref2.image,
      heading = _ref2.heading,
      headingAfterElement = _ref2.headingAfterElement,
      theme = _ref2.theme,
      innerRef = _ref2.innerRef;
  var _components$Header = components.Header,
      Header = _components$Header === void 0 ? DefaultHeader : _components$Header,
      _components$Footer = components.Footer,
      Footer = _components$Footer === void 0 ? DefaultFooter : _components$Footer;
  return /*#__PURE__*/React.createElement(Theme.Provider, {
    value: theme
  }, /*#__PURE__*/React.createElement(Theme.Consumer, null, function (_ref3) {
    var container = _ref3.container;
    return /*#__PURE__*/React.createElement(Container, {
      theme: container,
      ref: innerRef
    }, typeof image === 'string' ? /*#__PURE__*/React.createElement("img", {
      src: image,
      alt: ""
    }) : image, /*#__PURE__*/React.createElement(Body$1, null, heading || headingAfterElement ? /*#__PURE__*/React.createElement(Header, null, /*#__PURE__*/React.createElement(Heading$2, null, heading), headingAfterElement || /*#__PURE__*/React.createElement("span", null)) : null, children, actions.length > 0 || actionsBeforeElement ? /*#__PURE__*/React.createElement(Footer, null, actionsBeforeElement || /*#__PURE__*/React.createElement("span", null), /*#__PURE__*/React.createElement(ActionItems, null, actions.map(function (_ref4, idx) {
      var text = _ref4.text,
          key = _ref4.key,
          rest = _objectWithoutProperties$2(_ref4, ["text", "key"]);

      return /*#__PURE__*/React.createElement(ActionItem$1, {
        key: key || (typeof text === 'string' ? text : "".concat(idx))
      }, /*#__PURE__*/React.createElement(Button, rest, text));
    }))) : null));
  }));
};

var Card$1 = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(Card, _extends$1({}, props, {
    innerRef: ref
  }));
});

function _extends$2() { _extends$2 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends$2.apply(this, arguments); }

function _typeof$2(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$2 = function _typeof(obj) { return typeof obj; }; } else { _typeof$2 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$2(obj); }

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { _defineProperty$3(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties$3(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$3(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$3(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck$1(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties$1(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass$1(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties$1(Constructor.prototype, protoProps); if (staticProps) _defineProperties$1(Constructor, staticProps); return Constructor; }

function _inherits$1(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf$1(subClass, superClass); }

function _setPrototypeOf$1(o, p) { _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf$1(o, p); }

function _createSuper$1(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$1(); return function _createSuperInternal() { var Super = _getPrototypeOf$1(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf$1(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn$1(this, result); }; }

function _possibleConstructorReturn$1(self, call) { if (call && (_typeof$2(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized$1(self); }

function _assertThisInitialized$1(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct$1() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf$1(o) { _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf$1(o); }

function _defineProperty$3(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var N0$1 = colors.N0,
    N50A$1 = colors.N50A,
    N60A$1 = colors.N60A,
    P300$1 = colors.P300;

var SpotlightCard = /*#__PURE__*/function (_React$Component) {
  _inherits$1(SpotlightCard, _React$Component);

  var _super = _createSuper$1(SpotlightCard);

  function SpotlightCard() {
    _classCallCheck$1(this, SpotlightCard);

    return _super.apply(this, arguments);
  }

  _createClass$1(SpotlightCard, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          actions = _this$props.actions,
          actionsBeforeElement = _this$props.actionsBeforeElement,
          children = _this$props.children,
          components = _this$props.components,
          isFlat = _this$props.isFlat,
          heading = _this$props.heading,
          headingAfterElement = _this$props.headingAfterElement,
          image = _this$props.image,
          innerRef = _this$props.innerRef,
          _theme = _this$props.theme,
          width = _this$props.width;
      return /*#__PURE__*/React.createElement(Theme$1.Provider, {
        value: spotlightButtonTheme
      }, /*#__PURE__*/React.createElement(Card$1, {
        ref: innerRef,
        heading: heading,
        headingAfterElement: headingAfterElement,
        actions: actions,
        actionsBeforeElement: actionsBeforeElement,
        components: components,
        image: image,
        theme: function theme(parent) {
          var _parent = parent({}),
              container = _parent.container,
              others = _objectWithoutProperties$3(_parent, ["container"]);

          return _theme(function () {
            return _objectSpread$2(_objectSpread$2({}, others), {}, {
              container: _objectSpread$2({
                background: P300$1,
                color: N0$1,
                width: "".concat(Math.min(Math.max(width, 160), 600), "px"),
                boxShadow: isFlat ? undefined : "0 4px 8px -2px ".concat(N50A$1, ", 0 0 1px ").concat(N60A$1)
              }, container)
            });
          }, {});
        }
      }, children));
    }
  }]);

  return SpotlightCard;
}(React.Component);

_defineProperty$3(SpotlightCard, "defaultProps", {
  width: 400,
  isFlat: false,
  components: {},
  theme: function theme(themeFn) {
    return themeFn();
  }
});

var SpotlightCard$1 = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(SpotlightCard, _extends$2({}, props, {
    innerRef: ref
  }));
});

function _typeof$3(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$3 = function _typeof(obj) { return typeof obj; }; } else { _typeof$3 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$3(obj); }

function _classCallCheck$2(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties$2(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass$2(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties$2(Constructor.prototype, protoProps); if (staticProps) _defineProperties$2(Constructor, staticProps); return Constructor; }

function _inherits$2(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf$2(subClass, superClass); }

function _setPrototypeOf$2(o, p) { _setPrototypeOf$2 = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf$2(o, p); }

function _createSuper$2(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$2(); return function _createSuperInternal() { var Super = _getPrototypeOf$2(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf$2(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn$2(this, result); }; }

function _possibleConstructorReturn$2(self, call) { if (call && (_typeof$3(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized$2(self); }

function _assertThisInitialized$2(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct$2() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf$2(o) { _getPrototypeOf$2 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf$2(o); }

// This component was born from the pain of using render props in lifecycle methods.
// On update, it checks whether the current value prop is equal to the previous value prop.
// If they are different, it calls the onChange function.
// We use this for updating Popper when the SpotlightDialog width changes.
var ValueChanged = /*#__PURE__*/function (_React$Component) {
  _inherits$2(ValueChanged, _React$Component);

  var _super = _createSuper$2(ValueChanged);

  function ValueChanged() {
    _classCallCheck$2(this, ValueChanged);

    return _super.apply(this, arguments);
  }

  _createClass$2(ValueChanged, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.value !== this.props.value) {
        this.props.onChange();
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return ValueChanged;
}(React.Component);

function _typeof$4(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$4 = function _typeof(obj) { return typeof obj; }; } else { _typeof$4 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$4(obj); }

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { _defineProperty$4(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties$4(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$4(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$4(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck$3(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties$3(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass$3(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties$3(Constructor.prototype, protoProps); if (staticProps) _defineProperties$3(Constructor, staticProps); return Constructor; }

function _inherits$3(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf$3(subClass, superClass); }

function _setPrototypeOf$3(o, p) { _setPrototypeOf$3 = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf$3(o, p); }

function _createSuper$3(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$3(); return function _createSuperInternal() { var Super = _getPrototypeOf$3(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf$3(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn$3(this, result); }; }

function _possibleConstructorReturn$3(self, call) { if (call && (_typeof$4(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized$3(self); }

function _assertThisInitialized$3(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct$3() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf$3(o) { _getPrototypeOf$3 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf$3(o); }

function _defineProperty$4(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SpotlightDialog = /*#__PURE__*/function (_Component) {
  _inherits$3(SpotlightDialog, _Component);

  var _super = _createSuper$3(SpotlightDialog);

  function SpotlightDialog() {
    var _this;

    _classCallCheck$3(this, SpotlightDialog);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty$4(_assertThisInitialized$3(_this), "state", {
      focusLockDisabled: true
    });

    return _this;
  }

  _createClass$3(SpotlightDialog, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        // we delay the enabling of the focus lock to avoid the scroll position
        // jumping around in some situations
        _this2.setState({
          focusLockDisabled: false
        });
      }, 200);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          actions = _this$props.actions,
          actionsBeforeElement = _this$props.actionsBeforeElement,
          animationStyles = _this$props.animationStyles,
          children = _this$props.children,
          dialogPlacement = _this$props.dialogPlacement,
          dialogWidth = _this$props.dialogWidth,
          footer = _this$props.footer,
          header = _this$props.header,
          heading = _this$props.heading,
          image = _this$props.image,
          targetNode = _this$props.targetNode;
      var focusLockDisabled = this.state.focusLockDisabled;
      var translatedPlacement = dialogPlacement ? {
        'top left': 'top-start',
        'top center': 'top',
        'top right': 'top-end',
        'right top': 'right-start',
        'right middle': 'right',
        'right bottom': 'right-end',
        'bottom left': 'bottom-start',
        'bottom center': 'bottom',
        'bottom right': 'bottom-end',
        'left top': 'left-start',
        'left middle': 'left',
        'left bottom': 'left-end'
      }[dialogPlacement] : undefined;
      return /*#__PURE__*/React.createElement(Popper, {
        referenceElement: targetNode,
        placement: translatedPlacement
      }, function (_ref) {
        var ref = _ref.ref,
            style = _ref.style,
            update = _ref.update;
        return /*#__PURE__*/React.createElement(ValueChanged, {
          value: dialogWidth,
          onChange: update
        }, /*#__PURE__*/React.createElement(FocusLock, {
          disabled: focusLockDisabled,
          returnFocus: false,
          autoFocus: true
        }, /*#__PURE__*/React.createElement(SpotlightCard$1, {
          ref: ref,
          theme: function theme(parent) {
            var _parent = parent({}),
                container = _parent.container,
                others = _objectWithoutProperties$4(_parent, ["container"]);

            return _objectSpread$3(_objectSpread$3({}, others), {}, {
              container: _objectSpread$3(_objectSpread$3(_objectSpread$3({}, container), style), animationStyles)
            });
          },
          width: dialogWidth,
          actions: actions,
          actionsBeforeElement: actionsBeforeElement,
          image: image && /*#__PURE__*/React.createElement(Image$1, {
            alt: heading,
            src: image
          }),
          components: {
            Header: header,
            Footer: footer
          },
          heading: heading
        }, children)));
      });
    }
  }]);

  return SpotlightDialog;
}(Component);

var createAndFireEventOnAtlaskit = createAndFireEvent('atlaskit');
var SpotlightDialog$1 = withAnalyticsContext({
  componentName: 'spotlight',
  packageName: pkg.name,
  packageVersion: pkg.version
})(withAnalyticsEvents({
  targetOnClick: createAndFireEventOnAtlaskit({
    action: 'clicked',
    actionSubject: 'spotlight',
    attributes: {
      componentName: 'spotlight',
      packageName: pkg.name,
      packageVersion: pkg.version
    }
  })
})(SpotlightDialog));

function _typeof$5(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$5 = function _typeof(obj) { return typeof obj; }; } else { _typeof$5 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$5(obj); }

function _classCallCheck$4(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties$4(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass$4(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties$4(Constructor.prototype, protoProps); if (staticProps) _defineProperties$4(Constructor, staticProps); return Constructor; }

function _inherits$4(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf$4(subClass, superClass); }

function _setPrototypeOf$4(o, p) { _setPrototypeOf$4 = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf$4(o, p); }

function _createSuper$4(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$4(); return function _createSuperInternal() { var Super = _getPrototypeOf$4(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf$4(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn$4(this, result); }; }

function _possibleConstructorReturn$4(self, call) { if (call && (_typeof$5(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized$4(self); }

function _assertThisInitialized$4(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct$4() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf$4(o) { _getPrototypeOf$4 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf$4(o); }

function _defineProperty$5(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var TransitionContext = /*#__PURE__*/createContext({
  isOpen: true,
  onExited: function onExited() {}
}); // checks if children exist and are truthy

var hasChildren = function hasChildren(children) {
  return React.Children.count(children) > 0 && React.Children.map(children, function (child) {
    return !!child;
  }).filter(Boolean).length > 0;
};

var Transition = /*#__PURE__*/function (_React$Component) {
  _inherits$4(Transition, _React$Component);

  var _super = _createSuper$4(Transition);

  function Transition() {
    var _this;

    _classCallCheck$4(this, Transition);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty$5(_assertThisInitialized$4(_this), "state", {
      currentChildren: undefined
    });

    _defineProperty$5(_assertThisInitialized$4(_this), "onExited", function () {
      _this.setState({
        currentChildren: _this.props.children
      });
    });

    return _this;
  }

  _createClass$4(Transition, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(TransitionContext.Provider, {
        value: {
          onExited: this.onExited,
          isOpen: hasChildren(this.props.children)
        }
      }, this.state.currentChildren);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var previousChildren = state.currentChildren;
      var exiting = hasChildren(previousChildren) && !hasChildren(props.children);
      return {
        currentChildren: exiting ? previousChildren : props.children
      };
    }
  }]);

  return Transition;
}(React.Component);

var SpotlightTransitionConsumer = TransitionContext.Consumer;

function _typeof$6(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$6 = function _typeof(obj) { return typeof obj; }; } else { _typeof$6 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$6(obj); }

function _classCallCheck$5(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties$5(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass$5(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties$5(Constructor.prototype, protoProps); if (staticProps) _defineProperties$5(Constructor, staticProps); return Constructor; }

function _inherits$5(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf$5(subClass, superClass); }

function _setPrototypeOf$5(o, p) { _setPrototypeOf$5 = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf$5(o, p); }

function _createSuper$5(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$5(); return function _createSuperInternal() { var Super = _getPrototypeOf$5(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf$5(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn$5(this, result); }; }

function _possibleConstructorReturn$5(self, call) { if (call && (_typeof$6(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized$5(self); }

function _assertThisInitialized$5(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct$5() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf$5(o) { _getPrototypeOf$5 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf$5(o); }

function _defineProperty$6(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SpotlightInner = /*#__PURE__*/function (_React$Component) {
  _inherits$5(SpotlightInner, _React$Component);

  var _super = _createSuper$5(SpotlightInner);

  function SpotlightInner() {
    var _this;

    _classCallCheck$5(this, SpotlightInner);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty$6(_assertThisInitialized$5(_this), "state", {
      // This is only used when targetReplacement is specified.
      // In this case, we have to render the targetReplacement component,
      // get a dom reference from that component, then render again passing
      // that reference into SpotlightDialog (Popper).
      replacementElement: null
    });

    _defineProperty$6(_assertThisInitialized$5(_this), "isPositionFixed", function (element) {
      return window.getComputedStyle(element).position === 'fixed';
    });

    _defineProperty$6(_assertThisInitialized$5(_this), "hasPositionFixedParent", function (element) {
      // Cast to to any - offsetParent should be of interface "HTMLElement" instead of "Element"
      var offsetParent = element.offsetParent;

      if (!offsetParent) {
        return false;
      }

      if (_this.isPositionFixed(offsetParent)) {
        return true;
      }

      return _this.hasPositionFixedParent(offsetParent);
    });

    _defineProperty$6(_assertThisInitialized$5(_this), "getTargetNodeStyle", function () {
      if (!canUseDOM) {
        return {};
      }

      var targetNode = _this.props.targetNode;

      var _targetNode$getBoundi = targetNode.getBoundingClientRect(),
          height = _targetNode$getBoundi.height,
          left = _targetNode$getBoundi.left,
          top = _targetNode$getBoundi.top,
          width = _targetNode$getBoundi.width;

      if (_this.isPositionFixed(targetNode) || _this.hasPositionFixedParent(targetNode)) {
        return {
          height: height,
          left: left,
          top: top,
          width: width,
          // fixed position holds the target in place if overflow/scroll is necessary
          position: 'fixed'
        };
      }

      return {
        height: height,
        left: left + window.pageXOffset,
        top: top + window.pageYOffset,
        width: width,
        position: 'absolute'
      };
    });

    return _this;
  }

  _createClass$5(SpotlightInner, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.targetNode !== this.props.targetNode) {
        scrollIntoView(this.props.targetNode, {
          scrollMode: 'if-needed'
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      scrollIntoView(this.props.targetNode, {
        scrollMode: 'if-needed'
      });
      this.props.onOpened();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.props.onClosed();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          pulse = _this$props.pulse,
          target = _this$props.target,
          targetNode = _this$props.targetNode,
          targetBgColor = _this$props.targetBgColor,
          targetOnClick = _this$props.targetOnClick,
          targetRadius = _this$props.targetRadius,
          TargetReplacement = _this$props.targetReplacement;
      var replacementElement = this.state.replacementElement;
      return /*#__PURE__*/React.createElement(SpotlightTransitionConsumer, null, function (_ref) {
        var isOpen = _ref.isOpen,
            onExited = _ref.onExited;
        return /*#__PURE__*/React.createElement(Portal, {
          zIndex: layers.spotlight() + 1
        }, TargetReplacement ? /*#__PURE__*/React.createElement(NodeResovler, {
          innerRef: function innerRef(elem) {
            return _this2.setState({
              replacementElement: elem
            });
          }
        }, /*#__PURE__*/React.createElement(TargetReplacement, _this2.getTargetNodeStyle())) : /*#__PURE__*/React.createElement(Clone, {
          pulse: pulse,
          target: target,
          style: _this2.getTargetNodeStyle(),
          targetBgColor: targetBgColor,
          targetNode: targetNode,
          targetOnClick: targetOnClick,
          targetRadius: targetRadius
        }), TargetReplacement && !replacementElement ? null : /*#__PURE__*/React.createElement(Fade, {
          "in": isOpen,
          onExited: onExited
        }, function (animationStyles) {
          return /*#__PURE__*/React.createElement(SpotlightDialog$1, {
            actions: _this2.props.actions,
            actionsBeforeElement: _this2.props.actionsBeforeElement,
            children: _this2.props.children,
            dialogPlacement: _this2.props.dialogPlacement,
            dialogWidth: _this2.props.dialogWidth,
            footer: _this2.props.footer,
            header: _this2.props.header,
            heading: _this2.props.heading,
            image: _this2.props.image,
            targetNode: replacementElement || targetNode,
            animationStyles: animationStyles
          });
        }), /*#__PURE__*/React.createElement(ScrollLock, null));
      });
    }
  }]);

  return SpotlightInner;
}(React.Component);

_defineProperty$6(SpotlightInner, "defaultProps", {
  dialogWidth: 400,
  pulse: true
});

// we can't use @uidu/blanket
// because it has to sit on top of other layered elements (i.e. Modal).

var backgroundColor = themed({
  light: colors.N100A,
  dark: colors.DN90A
}); // IE11 and Edge: z-index needed because fixed position calculates z-index relative
// to body insteadof nearest stacking context (Portal in our case).

var Blanket = styled.div.withConfig({
  displayName: "Blanket",
  componentId: "sc-1wmlblc-0"
})(["background:", ";bottom:0;left:0;position:fixed;right:0;top:0;transition:opacity 220ms;z-index:", ";"], function (p) {
  return p.isTinted ? backgroundColor : 'transparent';
}, layers.spotlight);

function _typeof$7(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$7 = function _typeof(obj) { return typeof obj; }; } else { _typeof$7 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$7(obj); }

function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$4(Object(source), true).forEach(function (key) { _defineProperty$7(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$4(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck$6(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties$6(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass$6(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties$6(Constructor.prototype, protoProps); if (staticProps) _defineProperties$6(Constructor, staticProps); return Constructor; }

function _inherits$6(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf$6(subClass, superClass); }

function _setPrototypeOf$6(o, p) { _setPrototypeOf$6 = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf$6(o, p); }

function _createSuper$6(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$6(); return function _createSuperInternal() { var Super = _getPrototypeOf$6(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf$6(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn$6(this, result); }; }

function _possibleConstructorReturn$6(self, call) { if (call && (_typeof$7(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized$6(self); }

function _assertThisInitialized$6(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct$6() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf$6(o) { _getPrototypeOf$6 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf$6(o); }

function _defineProperty$7(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var noop$1 = function noop() {};

var _createContext = /*#__PURE__*/createContext(undefined),
    TargetConsumer = _createContext.Consumer,
    TargetProvider = _createContext.Provider;

var _createContext2 = /*#__PURE__*/createContext({
  opened: noop$1,
  closed: noop$1,
  targets: {}
}),
    SpotlightStateConsumer = _createContext2.Consumer,
    SpotlightStateProvider = _createContext2.Provider;

var Container$1 = function Container(_ref) {
  var Wrapper = _ref.component,
      children = _ref.children;
  return /*#__PURE__*/React.createElement(Wrapper, null, children);
};

var SpotlightManager = /*#__PURE__*/function (_PureComponent) {
  _inherits$6(SpotlightManager, _PureComponent);

  var _super = _createSuper$6(SpotlightManager);

  function SpotlightManager() {
    var _this;

    _classCallCheck$6(this, SpotlightManager);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty$7(_assertThisInitialized$6(_this), "state", {
      spotlightCount: 0,
      targets: {}
    });

    _defineProperty$7(_assertThisInitialized$6(_this), "targetRef", function (name) {
      return function (element) {
        _this.setState(function (state) {
          return {
            targets: _objectSpread$4(_objectSpread$4({}, state.targets), {}, _defineProperty$7({}, name, element || undefined))
          };
        });
      };
    });

    _defineProperty$7(_assertThisInitialized$6(_this), "spotlightOpen", function () {
      _this.setState(function (state) {
        return {
          spotlightCount: state.spotlightCount + 1
        };
      });
    });

    _defineProperty$7(_assertThisInitialized$6(_this), "spotlightClose", function () {
      _this.setState(function (state) {
        return {
          spotlightCount: state.spotlightCount - 1
        };
      });
    });

    _defineProperty$7(_assertThisInitialized$6(_this), "getStateProviderValue", memoizeOne(function (targets) {
      return {
        opened: _this.spotlightOpen,
        closed: _this.spotlightClose,
        targets: targets
      };
    }));

    return _this;
  }

  _createClass$6(SpotlightManager, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (process.env.NODE_ENV !== 'production' && !process.env.CI) {
        if (this.props.component) {
          // eslint-disable-next-line no-console
          console.warn("Atlaskit: The SpotlightManager 'component' prop is deprecated. Please wrap the SpotlightManager in the component instead.");
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          blanketIsTinted = _this$props.blanketIsTinted,
          children = _this$props.children,
          Tag = _this$props.component;
      return /*#__PURE__*/React.createElement(SpotlightStateProvider, {
        value: this.getStateProviderValue(this.state.targets)
      }, /*#__PURE__*/React.createElement(TargetProvider, {
        value: this.targetRef
      }, /*#__PURE__*/React.createElement(Container$1, {
        component: Tag || React.Fragment
      }, /*#__PURE__*/React.createElement(Fade, {
        "in": this.state.spotlightCount > 0
      }, function (animationStyles) {
        return /*#__PURE__*/React.createElement(Portal, {
          zIndex: layers.spotlight()
        }, /*#__PURE__*/React.createElement(Blanket, {
          style: animationStyles,
          isTinted: blanketIsTinted
        }));
      }), children)));
    }
  }]);

  return SpotlightManager;
}(PureComponent);

_defineProperty$7(SpotlightManager, "defaultProps", {
  blanketIsTinted: true
});

function _typeof$8(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$8 = function _typeof(obj) { return typeof obj; }; } else { _typeof$8 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$8(obj); }

function _extends$3() { _extends$3 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends$3.apply(this, arguments); }

function _objectWithoutProperties$5(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$5(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$5(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck$7(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties$7(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass$7(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties$7(Constructor.prototype, protoProps); if (staticProps) _defineProperties$7(Constructor, staticProps); return Constructor; }

function _inherits$7(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf$7(subClass, superClass); }

function _setPrototypeOf$7(o, p) { _setPrototypeOf$7 = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf$7(o, p); }

function _createSuper$7(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$7(); return function _createSuperInternal() { var Super = _getPrototypeOf$7(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf$7(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn$7(this, result); }; }

function _possibleConstructorReturn$7(self, call) { if (call && (_typeof$8(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized$7(self); }

function _assertThisInitialized$7(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct$7() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf$7(o) { _getPrototypeOf$7 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf$7(o); }

function _defineProperty$8(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Spotlight = /*#__PURE__*/function (_React$Component) {
  _inherits$7(Spotlight, _React$Component);

  var _super = _createSuper$7(Spotlight);

  function Spotlight() {
    _classCallCheck$7(this, Spotlight);

    return _super.apply(this, arguments);
  }

  _createClass$7(Spotlight, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          targetNode = _this$props.targetNode,
          target = _this$props.target,
          rest = _objectWithoutProperties$5(_this$props, ["targetNode", "target"]);

      return /*#__PURE__*/React.createElement(SpotlightStateConsumer, null, function (_ref) {
        var opened = _ref.opened,
            closed = _ref.closed,
            targets = _ref.targets;
        // use the targetNode prop or try get the target from context targets using name
        var actualTargetNode = targetNode || (typeof target === 'string' ? targets[target] : undefined);
        return actualTargetNode ? /*#__PURE__*/React.createElement(SpotlightInner, _extends$3({}, rest, {
          targetNode: actualTargetNode,
          target: target,
          onOpened: opened,
          onClosed: closed
        })) : null;
      });
    }
  }]);

  return Spotlight;
}(React.Component);

_defineProperty$8(Spotlight, "defaultProps", {
  dialogWidth: 400,
  pulse: true
});

function _typeof$9(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$9 = function _typeof(obj) { return typeof obj; }; } else { _typeof$9 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$9(obj); }

function _classCallCheck$8(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties$8(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass$8(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties$8(Constructor.prototype, protoProps); if (staticProps) _defineProperties$8(Constructor, staticProps); return Constructor; }

function _inherits$8(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf$8(subClass, superClass); }

function _setPrototypeOf$8(o, p) { _setPrototypeOf$8 = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf$8(o, p); }

function _createSuper$8(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$8(); return function _createSuperInternal() { var Super = _getPrototypeOf$8(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf$8(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn$8(this, result); }; }

function _possibleConstructorReturn$8(self, call) { if (call && (_typeof$9(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized$8(self); }

function _assertThisInitialized$8(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct$8() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf$8(o) { _getPrototypeOf$8 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf$8(o); }

var SpotlightTarget = /*#__PURE__*/function (_Component) {
  _inherits$8(SpotlightTarget, _Component);

  var _super = _createSuper$8(SpotlightTarget);

  function SpotlightTarget() {
    _classCallCheck$8(this, SpotlightTarget);

    return _super.apply(this, arguments);
  }

  _createClass$8(SpotlightTarget, [{
    key: "render",
    value: function render() {
      var _this = this;

      return /*#__PURE__*/React.createElement(TargetConsumer, null, function (targetRef) {
        return targetRef ? /*#__PURE__*/React.createElement(NodeResovler, {
          innerRef: targetRef(_this.props.name)
        }, _this.props.children) : _this.props.children;
      });
    }
  }]);

  return SpotlightTarget;
}(Component);

export { OnboardingModal as Modal, Spotlight, SpotlightCard$1 as SpotlightCard, SpotlightManager, Pulse as SpotlightPulse, SpotlightTarget, Transition as SpotlightTransition };
